%define install_dir /opt/mattermost
%define debug_package %{nil}

Name:		mattermost-src-git
Version:	2016Aug3
Release:	2%{?dist}
Summary:	Mattermost is an open source, self-hosted Slack-alternative
Group:		System Environment/Daemons
License:	AGPLv3 and ASL 2.0
URL:		https://mattermost.com
# Download latest with this URL: https://github.com/mattermost/platform/archive/master.tar.gz
Source0:	mattermost-git.tar.gz
Source1:	mattermost.service
Source2:	mattermost.sh
Source3:	mattermost.conf
Patch0:		mm-ldap.patch

BuildRequires:	golang
BuildRequires:	git
BuildRequires:  python
BuildRequires:  resolv-conf
BuildRequires:  nodejs
BuildRequires:  libpng12

Requires:	nginx
Requires:	postgresql = 9.4, postgresql-server = 9.4, postgresql-contrib = 9.4

BuildArch:	x86_64

%description
As an alternative to proprietary SaaS messaging, Mattermost brings all your team
communication into one place, making it searchable and accessible anywhere. It’s
written in Golang and React and runs as a production-ready Linux binary under an
MIT license with either MySQL or Postgres.

Mattermost is:

 - Slack-compatible, not Slack-limited – Mattermost features rival Slack 
   features, and support a superset of Slack’s incoming and outgoing webhook 
   integrations, including compatibility with existing Slack integrations. From
   your existing Slack teams, you can import users, public channel history and 
   even theme setting colors into Mattermost.
 - Mobile and desktop apps, in addition to web – Use Mattermost from your iOS or
   Android phones and tablets or with installed apps on Windows, Linux and Mac.
 - Easy to deploy, manage, and upgrade – Mattermost runs as Linux binary, Docker
   image, and many other forms. Try Mattermost with a one-line Docker install, 
   and many install guides are available. Improvements ship monthly.
 - Supported by a vibrant community – Use Mattermost with dozens of community
   integrations and applications, including Jira, IRC, XMPP, Hubot, Giphy, 
   Jenkins, GitLab, Trac, Redmine, SVN, RSS/Atom and many others. Build and 
   share your own apps using Mattermost APIs and drivers.


%prep
%setup -q -n platform-master
%patch0 -p1
cd %{_builddir}/platform-master
cd vendor
mkdir src
mv src ..
mv * ../src
mv ../src src
mkdir -p src/github.com/mattermost
cd src/github.com/mattermost
ln -s %{_builddir}/platform-master platform

%build
cd %{_builddir}/platform-master
# Adapted from AUR PKGBUILD
sed -n '1,/cp README.md/p;/^run-server:/,$p' -i Makefile
sed -r -i Makefile \
  -e 's/^package: build build-client/package: build-linux build-client/' \
  -e 's/^build: build-linux build-windows build-osx/build: build-linux/' \
  -e 's/GOARCH=amd64//' \
  -e 's/^BUILD_HASH =.*/BUILD_HASH = none/'
GOPATH="%{_builddir}/platform-master/vendor" GOBIN="$GOPATH/bin" BUILD_NUMBER="%{version}-%{release}" make package

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{install_dir}
cp -r dist/mattermost/* %{buildroot}%{install_dir}
cp vendor/bin/platform-master %{buildroot}%{install_dir}/bin/platform
mkdir %{buildroot}%{install_dir}/data

cd %{_builddir}
install -Dm644 %{SOURCE1} %{buildroot}/usr/lib/systemd/system/mattermost.service
install -Dm755 %{SOURCE2} %{buildroot}/usr/bin/mattermost
install -Dm600 %{SOURCE3} %{buildroot}/etc/nginx/conf.d

%files
%defattr(660, mattermost, mattermost, 771)
%{install_dir}/*
%attr(644, root, root) /usr/lib/systemd/system/mattermost.service
%attr(755, root, root) /usr/bin/mattermost
%attr(600, root, root) /etc/nginx/conf.d
%attr(755, mattermost, mattermost) %{install_dir}/bin/platform
%config %{install_dir}/config/config.json
%doc %{install_dir}/README.md
%doc %{install_dir}/NOTICE.txt
%license %{install_dir}/MIT-COMPILED-LICENSE.md

%pre
useradd -r mattermost -U

%changelog
* Thu Aug 4 2016 Alexander Pavel <anp120@jla.rutgers.edu> - 2016Aug3-2
- Include bin/platform (which is not it dist folder for some reason)
- Set attributes for files
- Add mattermost service
- Add mattermost nginx conf
- Add mattermost user
- Add mattermost shell script in /usr/bin
- Add nginx and postgresql dependencies

* Wed Aug 3 2016 Alexander Pavel <anp120@jla.rutgers.edu> - 2016Aug3-1
- Make git version
- Build from source
- Enable ldap for internal testing purposes

* Fri Jul 15 2016 Derek Maciel <dam402@nbcs.rutgers.edu> - 3.1.0-1
 - Initial build for Rutgers CentOS 7
